<?php
/**
 * Plugin Name: Permitir checkout segun codigo postal
 * Description: Adds custom fields to WooCommerce products.
 * Version: 1.0
 */
 
add_action( 'woocommerce_checkout_process', 'validate_postcode_on_checkout' );

function validate_postcode_on_checkout() {
    $order = wc_get_checkout_order();
    $billing_postcode = WC()->customer->get_billing_postcode();
    $products = $order->get_items();
    $postcodes = array();
    
    // Recorremos los productos para obtener los códigos postales válidos
    foreach ( $products as $product ) {
        $product_id = $product->get_product_id();
        $enable_postcode_restriction = get_post_meta( $product_id, '_enable_postcode_restriction', true );
        $custom_postcode_field = get_post_meta( $product_id, '_custom_postcode_field', true );
        
        if ( $enable_postcode_restriction == 'yes' && $custom_postcode_field ) {
            $postcodes = array_merge( $postcodes, explode( ',', $custom_postcode_field ) );
        }
    }
}

function validate_postcode_on_checkout() {
    // Código anterior
    
    if ( ! in_array( $billing_postcode, $postcodes ) ) {
        wc_add_notice( __( 'One or more products are not available for sale in this postcode', 'woocommerce' ), 'error' );
    }
}

function validate_postcode_on_checkout() {
    // Código anterior
    
    // Eliminamos códigos postales duplicados
    $postcodes = array_unique( $postcodes );
}